> For the complete documentation index, see [llms.txt](https://docs.projectlarix.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.projectlarix.com/contract/technical-resources/reserve.md).

# Reserve

#### pub struct Reserve

* description: Lending market reserve state
* variable:&#x20;

> ```rust
> pub struct Reserve {
> Version of the struct
> pub version: u8,
> Last slot when supply and rates updated
> pub last_update: LastUpdate,
> Lending market address
> pub lending_market: Pubkey,
> Reserve liquidity
> pub liquidity: ReserveLiquidity,
> Reserve collateral
> pub collateral: ReserveCollateral,
> Reserve configuration values
> pub config: ReserveConfig,
> ```

#### pub struct ReserveLiquidity

* description: Reserve liquidity
* variable:

> ```rust
> Reserve liquidity mint address
> pub mint_pubkey: Pubkey,
> Reserve liquidity mint decimals
> pub mint_decimals: u8,
> Reserve liquidity supply address
> pub supply_pubkey: Pubkey,
> Reserve liquidity fee receiver address
> pub fee_receiver: Pubkey,
> Reserve liquidity oracle account
> pub oracle_pubkey: Pubkey,
> Reserve liquidity available
> pub available_amount: u64,
> Reserve liquidity borrowed
> pub borrowed_amount_wads: Decimal,
> Reserve liquidity cumulative borrow rate
> pub cumulative_borrow_rate_wads: Decimal,
> Reserve liquidity market price in quote currency
> pub market_price: Decimal,
> ```

#### pub struct ReserveLiquidity

* description: Reserve collateral
* variable:&#x20;

> ```rust
> /// Reserve collateral mint address
> pub mint_pubkey: Pubkey,
> /// Reserve collateral mint supply, used for exchange rate
> pub mint_total_supply: u64,
> /// Reserve collateral supply address
> pub supply_pubkey: Pubkey,
> ```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.projectlarix.com/contract/technical-resources/reserve.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
